#include <stdio.h>
#include "genrand.h"
#include <sys/types.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#define MAXCOORD 1000000

main(argc,argv)
int argc;
char *argv[];
{
	int maxcoord = MAXCOORD;
	int *a;
	int N;
	int i,j,k,step,changed;
	int x;
	int seed;
	int arg = 1;
	int tsplib = 0;

	if (argc < 3) {
		printf("Usage: tmatgen [-tsplib] #cities seed [maxcoord] > filename\n");
		exit(1);
		}
	if (strcmp(argv[arg], "-tsplib") == 0)  {
		tsplib = 1;
		++arg;
	}
	N = atoi(argv[arg++]);
	a = (int *) malloc(sizeof(int)*(N*(N+1)+1));
        
	seed = atoi(argv[arg++]);
	if (argc > arg) maxcoord = atoi(argv[arg++]);

	/* initialize random number generator */

	sprand(seed);

	for (i=1;i<=N;i++) {
	    for (j=1;j<=N;j++) {
		a[i*N+j] = rangerand(maxcoord);
	    }
	    a[i*N+i] = 0;
	}

	step=1;
	while (step<N) {
	  changed = 0;
	  for (i=1;i<=N;i++)
	    for (j=1;j<=N;j++)
		for (k=1;k<=N;k++) {
			x = a[i*N+k]+a[k*N+j];
			if (a[i*N+j] > x) {
			   changed = 1;
			   a[i*N+j] = x;
			}
		}
	  if (changed == 0) {
		break;
	  }
	  step *= 2;
	}

	if (tsplib) {
		printf("NAME: tmatgen_%d_%d_%d\n", N, seed, maxcoord);
		printf("TYPE: ATSP\n");
		printf("COMMENT: Asymmetric TSP (generated with 'tmatgen %d %d %d')\n",N, seed, maxcoord);
		printf("DIMENSION: %d\n", N);
		printf("EDGE_WEIGHT_TYPE: EXPLICIT\n");
		printf("EDGE_WEIGHT_FORMAT: FULL_MATRIX\n");
		printf("EDGE_WEIGHT_SECTION\n");
	}
	else {
		printf("%d A\n",N);
	}

	for (i=1;i<=N;i++)
	    for (j=1;j<=N;j++) printf("%d\n",a[i*N+j]);

	if (tsplib) {
		printf("EOF\n");
	}
	else {
		printf("tmatgen %d %d %d\n",N,seed,maxcoord);
	};
}
